## edu.wisc.ssec.mcidas
Class LALOnav

    java.lang.Object
      edu.wisc.ssec.mcidas.AREAnav
          edu.wisc.ssec.mcidas.LALOnav

All Implemented Interfaces:
  Serializable

public final class LALOnav
extends AREAnav

Navigation class for Radar (RECT) type nav. This code was modified from the original FORTRAN code (nvxrect.dlm) on the McIDAS system. It only supports latitude/longitude to line/element transformations (LL) and vice/versa. Transform to 'XYZ' not implemented.

See Also:
  McIDAS Programmer's Manual, Serialized Form

Field Summary
`(package private) int` `aux_size`
`(package private) int` `cols`
`(package private) int` `count`
`(package private) boolean` `debug`
`(package private) Gridded2DSet` `gs`
`(package private) int` `lat_aux_offset`
`(package private) float` `LAT_MISSING`
`(package private) float[]` `latData`
`(package private) int` `latpoint`
`(package private) int` `latres`
`(package private) int` `lon_aux_offset`
`(package private) float` `LON_MISSING`
`(package private) float[]` `lonData`
`(package private) int` `lonpoint`
`(package private) int` `lonres`
`(package private) int` `lrele`
`(package private) int` `lrlin`
`(package private) double` `maxlat`
`(package private) double` `maxlon`
`(package private) double` `minlat`
`(package private) double` `minlon`
`(package private) int` `numPoints`
`(package private) boolean` `Pos`
`(package private) int` `rows`
`(package private) int` `ulelem`
`(package private) int` `ulline`

Fields inherited from class edu.wisc.ssec.mcidas.AREAnav
`DEGREES_TO_RADIANS, DMSP, GMSX, GOES, GVAR, indexEle, indexLat, indexLine, indexLon, LALO, LAMB, LL, MERC, MOLL, MSAT, MSG, MSGT, POES, PS, RADIANS_TO_DEGREES, RADR, RECT, serialVersionUID, TANC, XY`

Constructor Summary
`LALOnav(int[] iparms, int[] auxBlock)` Set up for the real math work.

Method Summary
`double[][]` `toLatLon(double[][] linele)` converts from satellite coordinates to latitude/longitude
`float[][]` `toLatLon(float[][] linele)` converts from satellite coordinates to latitude/longitude
`double[][]` `toLinEle(double[][] latlon)` toLinEle converts lat/long to satellite line/element
`float[][]` `toLinEle(float[][] latlon)` transform an array of values in R^DomainDimension to an array of non-integer grid coordinates

Methods inherited from class edu.wisc.ssec.mcidas.AREAnav
`areaCoordToImageCoord, areaCoordToImageCoord, areaCoordToImageCoord, areaCoordToImageCoord, doubleToFloat, equals, floatToDouble, getLineOffset, imageCoordToAreaCoord, imageCoordToAreaCoord, imageCoordToAreaCoord, imageCoordToAreaCoord, isFlippedLineCoordinates, makeAreaNav, makeAreaNav, setFlipLineCoordinates, setImageStart, setMag, setMag, setRes, setRes, setStart, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### rows

    int rows

### cols

    int cols

### latres

    int latres

### lonres

    int lonres

### latpoint

    int latpoint

### lonpoint

    int lonpoint

### numPoints

    int numPoints

### ulline

    int ulline

### ulelem

    int ulelem

### aux_size

    int aux_size

### lat_aux_offset

    int lat_aux_offset

### lon_aux_offset

    int lon_aux_offset

### lrlin

    int lrlin

### lrele

    int lrele

### minlat

    double minlat

### maxlat

    double maxlat

### minlon

    double minlon

### maxlon

    double maxlon

### latData

    float[] latData

### lonData

    float[] lonData

### LAT_MISSING

    float LAT_MISSING

### LON_MISSING

    float LON_MISSING

### debug

    boolean debug

### count

    int count

### gs

    Gridded2DSet gs

### Pos

    boolean Pos

Constructor Detail

### LALOnav

    public LALOnav(int[] iparms,
                   int[] auxBlock)
            throws IllegalArgumentException

  Set up for the real math work. Must pass in the int array of the RECT nav 'codicil'.

Parameters:
  `iparms` - the nav block from the image file
Throws:
  `IllegalArgumentException` - if the nav block is not a RECT type.

Method Detail

### toLatLon

    public float[][] toLatLon(float[][] linele)

  converts from satellite coordinates to latitude/longitude

  Overrides:
    `toLatLon` in class `AREAnav`
  Returns:
    latlon[][] array of lat/long pairs. Output array is latlon[indexLat][] of latitudes and latlon[indexLon][] of longitudes. this code cobbled from McIDAS laloutil.c

### toLatLon

    public double[][] toLatLon(double[][] linele)

  Description copied from class: `AREAnav`
  converts from satellite coordinates to latitude/longitude

  Specified by:
    `toLatLon` in class `AREAnav`
  Returns:
    latlon[][] array of lat/long pairs. Output array is latlon[indexLat][] of latitudes and latlon[indexLon][] of longitudes.

### toLinEle

    public float[][] toLinEle(float[][] latlon)

  transform an array of values in R^DomainDimension to an array of non-integer grid coordinates

  Overrides:
    `toLinEle` in class `AREAnav`
  Returns:
    linele[][] array of line/element pairs. Where linele[indexLine][] is a line and linele[indexEle][] is an element. These are in 'file' coordinates (not "image" coordinates);

### toLinEle

    public double[][] toLinEle(double[][] latlon)

  Description copied from class: `AREAnav`
  toLinEle converts lat/long to satellite line/element

  Specified by:
    `toLinEle` in class `AREAnav`
  Returns:
    linele[][] array of line/element pairs. Where linele[indexLine][] is a line and linele[indexEle][] is an element. These are in 'file' coordinates (not "image" coordinates);